// ECommerceEngine.cpp : Defines the entry point for the console application.

#include "stdafx.h"
#include "ECommerceEngine.h"

int _tmain(int argc, _TCHAR* argv[])
{
    ECommerceEngine* myECommerceEngine = new ECommerceEngine();

    printf(myECommerceEngine->getStateCapabilities());

    printf("Now in the initial state\n");
    printf("Let's go buy some stuff - moving to the purchase state\n");

    myECommerceEngine->changeState(PurchaseState::Instance());
    printf(myECommerceEngine->getStateCapabilities());

    printf("No money left, better move into the exit state\n");
    myECommerceEngine->changeState(ExitState::Instance());
    printf(myECommerceEngine->getStateCapabilities());

    delete myECommerceEngine;

	return 0;
}

ECommerceEngine::ECommerceEngine(void)
{
    _state = NULL;
	changeState(InitialState::Instance());
}

char* ECommerceEngine::getStateCapabilities(void)
{
    return _state->whatCanWeDo();
}

ECommerceEngine::~ECommerceEngine(void)
{
}

void ECommerceEngine::changeState(State* pState)
{
	if (pState != _state)
	{
		_state = pState;
	}
}